-- Default localization - enUS
local ADDON_NAME = "GearGrinder";

local L = LibStub("AceLocale-3.0"):NewLocale(ADDON_NAME, "enUS", true);

L.core = {
	menuText = "Gear Grinder %s",
	versionText = "|cff00aa00%s|r",
	buttonLabel = "GearGrinder",
	buttonText = "%s %s",
	tooltip = "Gear Grinder",
	cooldownInfoText = "Resets:",
	cooldownInfoLastText = "Last Reset:",
	cooldownInfoNextText = "Next Reset:",
	cooldownInfoDay = "days",
	cooldownInfoHr = "hrs",
	cooldownInfoMin = "min",
	PDCharTextShort = "Characters",
	PDiLvlTextShort = "iLvl",
	PDVPText = "Valor Points",
	PDVPTextShort = "Valor",
	PDVPTooltip = "The amount of Valor Points your character currently has.",
	PDVPTooltipMax = "The maximum allowed is %s.",
	PDVPCapText = "Valor Progress",
	PDVPCapTextShort = "VP Cap",
	PDVPCapTooltip = "The number of Valor points earnt this week.",
	PDVPCapTooltipMax = "The weekly earning cap is %s.",
	PDJPText = "Justice Points",
	PDJPTextShort = "Justice",
	PDJPTooltip = "The amount of Justice Points your character currently has.",
	PDJPTooltipMax = "The maximum allowed is %s.",
	PDCharmText = "Lesser/Elder Charms",
	PDCharmTextShort = "Charms",
	PDActivityText = "Daily/Weekly Activities",
	PDActivityTextShort = "Activity",
	
	desc = "Records the Valor and Justice Point cap progress for all characters on the realm",
	name = "Gear Grinder",
    load = "Loading Gear Grinder |cff00aa00v%s|r by Azadan",
	
	BossTitle = "Bosses",
	BossGalleon = "Galleon",
	BossGalleonShort = "Galleon",
	BossShaOfAnger = "Sha of Anger",
	BossShaOfAngerShort = "Sha",
	BossOondasta = "Oondasta",
	BossOondastaShort = "Oondasta",
	BossNalak = "Nalak, the Storm Lord",
	BossNalakShort = "Nalak",
	BossLooted = "Dead",
	BossNotLooted = "Alive",
	
	LFRTitle = "Raids",
	LFR_MV = "MV",
	LFR_HoF = "HoF",
	LFR_ToES = "ToES",
	LFR_ToT = "ToT",
	
	ProfAlcText = "Alc",
	ProfBSText = "BS",
	ProfEnchText = "Ench",
	ProfScribeText = "Ins",
	ProfTailorText = "Cloth",
	ProfLWText = "LW",
	ProfJCGemText = "Gem",
	ProfJCHeartText = "Hrt",
	
	options = {
		name = "Gear Grinder Options",
		options = "General Options",
		minimap = "Show Minimap Button",
		minimapDesc = "Toggles showing the minimap button",
		dailyResetHour = "Daily Reset Hour",
		dailyResetHourDesc = "The hour of the day when the Daily Quests are reset.",
		resetHour = "Weekly Reset Hour",
		resetHourDesc = "The hour of the day when the weekly Valor Point Cap is reset.",
		resetDayOfWeek = "Weekly Reset Day",
		resetDayOfWeekDesc = "The day of the week when the weekly Valor Point Cap is reset.",
		activity = "Show Activities?",
		activityDesc = "Toggle to show/hide the Daily/Weekly Activity indicators",
		combat = "Show In-combat?",
		combatDesc = "Show the tooltip whilst in combat?",
		filtering = "Enable filtering?",
		filteringDesc = "Toggle to enable/disable character filtering.",
		profCD = "Enable Profession CDs?",
		profCDDesc = "Toggle to show/hide profession cooldowns.",
		farm = "Enable Farming?",
		farmDesc = "Toggle to show/hide farming progress.",
		instruction = "Help/Tutorial",
		instructionDesc = "Click to show the Gear Grinder Help page.",
		scale = "Set the Tooltip UI Scale",
		scaleDesc = "Tooltip UI scaling factor for the Tooltip. Default = 1.",
		paperdollVP = "Show Valor on Stats",
		paperdollVPDesc = "Shows your Valor Points on the Character Info window on the stats pane.",
		paperdollVPCap = "Show Progress on Stats",
		paperdollVPCapDesc = "Shows your Valor Points Cap Progress on the Character Info window on the stats pane.",
		paperdollJP = "Show Justice on Stats",
		paperdollJPDesc = "Shows your Justice Points on the Character Info window on the stats pane.",
		purge = "Erase Saved Details",
		purgeDesc = "Erase all the saved details for all characters.",
		ldb = "LDB Options",
		ldbText = "LDB Text",
		ldbTextDesc = "Toggle LDB on and off, this will save a little resources.",
		ldbTextColor = "LDB Text Colorize?",
		ldbTextColorDesc = "Toggle to turn on/off the changing colors of the text.",
		ldbSource = "LDB Source Label",
		ldbSourceDesc = "Show a label of the source data for the LDB Button.",
		ldbDisplay = "Button Text",
		ldbDisplayDesc = "Selection of the text to display on the LDB Button",
		ldbDisplayLock = "Lock the Button Text?",
		ldbDisplayLockDesc = "Toggle the locking of the LDB Button Text from being changed when being left-clicked.",
		optionDesc = "Open VP Cap Progress Options UI",
		charm = "Show Charms?",
		charmDesc = "Toggle to show/hide the Lesser and Elder Charm totals",
		H = "Daily H?",
		HDesc = "Toggle to show/hide the Daily Random Heroic Dungeon indicator",
		HS = "Daily HS?",
		HSDesc = "Toggle to show/hide the Daily Random Heroic Scenario indicator",
		S = "Daily S?",
		SDesc = "Toggle to show/hide the Daily Random Scenario indicator",
		C = "Daily C?",
		CDesc = "Toggle to show/hide the Daily Challenge Mode Dungeon quest indicator",
		CoTK = "Weekly CoTK?",
		CoTKDesc = "Toggle to show/hide the Weekly Champion of the Thunder King quest indicator",
		BB = "Weekly BB?",
		BBDesc = "Toggle to show/hide the Weekly Battlefield: Barrens quest indicator",
		iLevel = "Show iLevels?",
		iLevelDesc = "Toggle to show/hide the Item Level.",
		sortOrder = "Sort Order",
		sortOrderDesc = "Selection of the Sort Order of the entries",
		boss = "Show World Bosses?",
		bossDesc = "Toggle to show/hide the World Boss kill status",
		showIcon = "Show Icons?",
		showIconDesc = "Toggle to show/hide the Icons.", 
		raid = "Show Raid Details?",
		raidDesc = "Toggle to show/hide the Raid Details.", 
		LFR = "Show Raid Details?",
		LFRDesc = "Toggle to show/hide the Raid Details.", 
		NonLFR = "Show Non-LFR Details?",
		NonLFRDesc = "Toggle to show/hide the Non-LFR Raid Saves.", 
		ttContent = "Tooltip Contents",
		ttActivity = "Activities Display",
		ttProfs = "Profession Cooldowns Display",
		ProfAlc = "Alchemy?",
		ProfAlcDesc = "Toggle to show/hide the daily Alchemy indicator",
		ProfBS = "Blacksmithing?",
		ProfBSDesc = "Toggle to show/hide the daily Blacksmithing indicator",
		ProfTailor = "Tailoring?",
		ProfTailorDesc = "Toggle to show/hide the daily Tailor indicator",
		ProfEnch = "Enchanting?",
		ProfEnchDesc = "Toggle to show/hide the daily Enchanting indicator",
		ProfScribe = "Inscription?",
		ProfScribeDesc = "Toggle to show/hide the daily Inscription indicator",
		ProfJCGem = "JC Gem?",
		ProfJCGemDesc = "Toggle to show/hide the daily Jewelcrafting Gem Craft indicator",
		ProfJCHeart = "JC Serpent's Heart?",
		ProfJCHeartDesc = "Toggle to show/hide the daily Jewelcrafting Serpent's Heart indicator",
		ProfLW = "Leatherworking?",
		ProfLWDesc = "Toggle to show/hide the daily Leatherworking indicator",
	
	}
}


